/*******************************************************************************
**  PROJECT NAME : OpenGL ES (GLUT32) compatibled Rotating Cube example.
**  
**  (C)Copyright2005 , Rage freeware
**  (C)Copyright2005 , Min Chul , Kim ( rageworx@gmail.com )
**
**  All Program codes protects by copyright-law of international. 
********************************************************************************/
#ifdef _WIN32
	#include <windows.h>
	#include <stdio.h>
	#include <math.h>
	#include <gl/glut.h>
#else
	#include <stdio.h>
	#include <math.h>
	#include "glwrap.h"
#endif
#include "app.h"

static int texture = 1;
static int fog = 0;
static double sx = 0;
static double sz = -8;
static GLfloat rotx = 30;
static GLfloat roty = 30;
static GLfloat rotz = 0;
static int autodrive = 1;
static int pointlight = 1;
static int wireframe = 0;
static int flatshade = 0;
static int supecular = 1;
static int rotidx = -1;
static int nowrot = 0;
static int nvtx = 0;
static GLfloat zoom_val = 0.5;

static GLfloat cube_vtx2[][3] = {
    { 0.4, 0.5, 0.4}, {-0.4, 0.5, 0.4}, { 0.4, 0.5,-0.4}, {-0.4, 0.5,-0.4},
    { 0.5,-0.4,-0.4}, { 0.5,-0.4, 0.4}, { 0.5, 0.4,-0.4}, { 0.5, 0.4, 0.4},
    { 0.4, 0.4,-0.5}, {-0.4, 0.4,-0.5}, { 0.4,-0.4,-0.5}, {-0.4,-0.4,-0.5},
    {-0.5, 0.4,-0.4}, {-0.5, 0.4, 0.4}, {-0.5,-0.4,-0.4}, {-0.5,-0.4, 0.4},
    {-0.4, 0.4, 0.5}, { 0.4, 0.4, 0.5}, {-0.4,-0.4, 0.5}, { 0.4,-0.4, 0.5},
    {-0.4,-0.5, 0.4}, { 0.4,-0.5, 0.4}, {-0.4,-0.5,-0.4}, { 0.4,-0.5,-0.4},
};

static GLfloat cubeedge_vtx[12*4][3];

static GLshort cubeedge_idx[] = {
    0, 2, 7, 6,
    2, 3, 8, 9,
    3, 1, 12, 13,
    1, 0, 16, 17,

    5, 4, 21, 23,
    10, 11, 23, 22,
    14, 15, 22, 20,
    18, 19, 20, 21,

    17, 7, 19, 5,
    6, 8, 4, 10,
    9, 12, 11, 14,
    13, 16, 15, 18,
};

static GLfloat cubeedge_norm[4*12][3];
#if 0
const GLfloat cubeedge_norm[][3] = {
    {0, 1, 0}, {0, 1, 0}, {1, 0, 0}, {1, 0, 0},
    {0, 1, 0}, {0, 1, 0}, {0, 0, -1}, {0, 0, -1},
    {0, 1, 0}, {0, 1, 0}, {-1, 0, 0}, {-1, 0, 0},
    {0, 1, 0}, {0, 1, 0}, {0, 0, 1}, {0, 0, 1},
 
    {1, 0, 0}, {1, 0, 0}, {0, -1, 0}, {0, -1, 0},
    {0, 0, -1}, {0, 0, -1}, {0,-1, 0}, {0,-1, 0},
    {-1, 0, 0}, {-1, 0, 0}, {0, -1, 0}, {0, -1, 0},
    {0, 0, 1}, {0, 0, 1}, {0, -1, 0}, {0, -1, 0},

    {0, 0, 1}, {1, 0, 0}, {0, 0, 1}, {1, 0, 0}, 
    {1, 0, 0}, {0, 0, -1}, {1, 0, 0}, {0, 0, -1}, 
    {0, 0, -1}, {-1, 0, 0}, {0, 0, -1}, {-1, 0, 0}, 
    {-1, 0, 0}, {0, 0, 1}, {-1, 0, 0}, {0, 0, 1}, 

};
#endif

const GLfloat cubeedge_color[] = Black;

static GLfloat cubecnr_vtx[8*3][3];

static GLshort cubecnr_idx[] = {
    0, 7, 17,
    2, 6, 8,
    3, 9, 12,
    1, 16, 13,

    21, 19, 5,
    23, 4, 10,
    22, 11, 14,
    20, 15, 18,
};

static GLfloat cubecnr_norm[8*3][3];

const GLfloat cube_coords[][3] = {
    { 0.42, 0.42, 0.42},
    { 0.42, 0.42,-0.42},
    {-0.42, 0.42,-0.42},
    {-0.42, 0.42, 0.42},
    { 0.42,-0.42, 0.42},
    { 0.42,-0.42,-0.42},
    {-0.42,-0.42,-0.42},
    {-0.42,-0.42, 0.42},
};

const GLshort cube_idx[] = {
    0, 3, 1, 2,
    5, 4, 1, 0,
    1, 2, 5, 6,
    2, 3, 6, 7,
    3, 0, 7, 4,
    7, 4, 6, 5,
};

const GLfloat cube_norm[][3] = {
    {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0},
    {1, 0, 0}, {1, 0, 0}, {1, 0, 0}, {1, 0, 0},
    {0, 0,-1}, {0, 0,-1}, {0, 0,-1}, {0, 0,-1},
    {-1, 0, 0}, {-1, 0, 0}, {-1, 0, 0}, {-1, 0, 0},
    {0, 0, 1}, {0, 0, 1}, {0, 0, 1}, {0, 0, 1},
    {0,-1, 0}, {0,-1, 0}, {0,-1, 0}, {0,-1, 0},
};

const int rottb[9][2][9] = {
    {{0, 1, 2, 3, 4, 5, 6, 7, 8}, {2, 5, 8, 1, 4, 7, 0, 3, 6}},
    {{9,10,11,12,13,14,15,16,17}, {11,14,17,10,13,16, 9,12,15}},
    {{18,19,20,21,22,23,24,25,26}, {20,23,26,19,22,25,18,21,24}},

    {{18,9,0,21,12,3,24,15,6}, {0,3,6,9,12,15,18,21,24}},
    {{19,10,1,22,13,4,25,16,7}, {1,4,7,10,13,16,19,22,25}},
    {{20,11,2,23,14,5,26,17,8}, {2,5,8,11,14,17,20,23,26}},

    {{6,7,8,15,16,17,24,25,26}, {8,17,26,7,16,25,6,15,24}},
    {{3,4,5,12,13,14,21,22,23}, {5,14,23,4,13,22,3,12,21}},
    {{0,1,2,9,10,11,18,19,20}, {2,11,20,1,10,19,0,9,18}},
};

const GLfloat pointlightPos[] = {-5, 5, 5, 1};
const GLfloat lightPos[] = {-5, 5, 5, 0};
const GLfloat lightCol[] = {1.0, 1.0, 1.0, 1.0};
const GLfloat lightNone[] = {0, 0, 0, 0};
//const GLfloat light0_ambient[]  = {0.3, 0.3, 0.3, 1.0};
const GLfloat light0_ambient[]  = {0.01, 0.01, 0.01, 1.0};
const GLfloat light0_specular[] = {1.0, 1.0, 1.0, 1.0};
const GLfloat materialCol[] = {0.5, 0.5, 0.5, 1.0};
const GLfloat material_specular[] = {1.0, 1.0, 1.0, 1.0};
const GLfloat BackClearColor[] = {0.1f , 0.1f , 0.3f , 1.0f};

static GLfloat cube_vtx[4*6][3];

typedef struct stCube
{
    GLfloat rx, ry, rz;
} Cube;

static Cube cube[27];
static int cubepos[27];

static GLfloat FaceColor[27][6][4] = {
   {  Black,  Black,    Red,   Blue,  Black,  Green },
   {  Black,  Black,    Red,  Black,  Black,  Green },
   {  Black, Purple,    Red,  Black,  Black,  Green },
   {  Black,  Black,    Red,   Blue,  Black,  Black },
   {  Black,  Black,    Red,  Black,  Black,  Black },
   {  Black, Purple,    Red,  Black,  Black,  Black },
   { Yellow,  Black,    Red,   Blue,  Black,  Black },
   { Yellow,  Black,    Red,  Black,  Black,  Black },
   { Yellow, Purple,    Red,  Black,  Black,  Black },
   {  Black,  Black,  Black,   Blue,  Black,  Green },
   {  Black,  Black,  Black,  Black,  Black,  Green },
   {  Black, Purple,  Black,  Black,  Black,  Green },
   {  Black,  Black,  Black,   Blue,  Black,  Black },
   {  Black,  Black,  Black,  Black,  Black,  Black },
   {  Black, Purple,  Black,  Black,  Black,  Black },
   { Yellow,  Black,  Black,   Blue,  Black,  Black },
   { Yellow,  Black,  Black,  Black,  Black,  Black },
   { Yellow, Purple,  Black,  Black,  Black,  Black },
   {  Black,  Black,  Black,   Blue,  White,  Green },
   {  Black,  Black,  Black,  Black,  White,  Green },
   {  Black, Purple,  Black,  Black,  White,  Green },
   {  Black,  Black,  Black,   Blue,  White,  Black },
   {  Black,  Black,  Black,  Black,  White,  Black },
   {  Black, Purple,  Black,  Black,  White,  Black },
   { Yellow,  Black,  Black,   Blue,  White,  Black },
   { Yellow,  Black,  Black,  Black,  White,  Black },
   { Yellow, Purple,  Black,  Black,  White,  Black }
};

static int FaceColorIdx[27][6];

static int shuffle_buf[N_SHUFFLE+1];
static int shuffle_rbuf[N_SHUFFLE+1];
static int *shufflep;

void rotcubes(int ridx)
{
    int i, j;
    int pos[9];
    int tmpc[6];

    for(i=0; i<9; i++) {
	pos[i]  = cubepos[rottb[ridx][1][i]];
    }
    for(i=0; i<9; i++) {
	cube[cubepos[rottb[ridx][0][i]]].rx = 0;
	cube[cubepos[rottb[ridx][0][i]]].ry = 0;
	cube[cubepos[rottb[ridx][0][i]]].rz = 0;
	cubepos[rottb[ridx][0][i]] = pos[i];
	for (j=0; j<6; j++) {
	    tmpc[j] = FaceColorIdx[cubepos[rottb[ridx][0][i]]][j];
	}
	switch (ridx) {
	case 0:
	case 1:
	case 2:
	    FaceColorIdx[cubepos[rottb[ridx][0][i]]][0] = tmpc[3];
	    FaceColorIdx[cubepos[rottb[ridx][0][i]]][1] = tmpc[0];
	    FaceColorIdx[cubepos[rottb[ridx][0][i]]][5] = tmpc[1];
	    FaceColorIdx[cubepos[rottb[ridx][0][i]]][3] = tmpc[5];
	    break;
	case 3:
	case 4:
	case 5:
	    FaceColorIdx[cubepos[rottb[ridx][0][i]]][0] = tmpc[4];
	    FaceColorIdx[cubepos[rottb[ridx][0][i]]][2] = tmpc[0];
	    FaceColorIdx[cubepos[rottb[ridx][0][i]]][5] = tmpc[2];
	    FaceColorIdx[cubepos[rottb[ridx][0][i]]][4] = tmpc[5];
	    break;
	case 6:
	case 7:
	case 8:
	    FaceColorIdx[cubepos[rottb[ridx][0][i]]][4] = tmpc[3];
	    FaceColorIdx[cubepos[rottb[ridx][0][i]]][1] = tmpc[4];
	    FaceColorIdx[cubepos[rottb[ridx][0][i]]][2] = tmpc[1];
	    FaceColorIdx[cubepos[rottb[ridx][0][i]]][3] = tmpc[2];
	    break;
	}
    }
}

void shuffle(void)
{
    int i;

    for (i=0; i<N_SHUFFLE; i++) {
	shuffle_buf[N_SHUFFLE-1-i] = rand() % 9;
	rotcubes(shuffle_buf[N_SHUFFLE-1-i]);
	rotcubes(shuffle_buf[N_SHUFFLE-1-i]);
	rotcubes(shuffle_buf[N_SHUFFLE-1-i]);
	shuffle_rbuf[i] = shuffle_buf[N_SHUFFLE-1-i]+10;
    }
    shuffle_buf[N_SHUFFLE] = -1; // end mark
    shuffle_rbuf[N_SHUFFLE] = -1; // end mark
    rotidx = -1;
    nowrot = 0;
    shufflep = shuffle_buf;
}

void showHelp(void)
{
    char tmpStr[512] = {0};
    
    strcpy(tmpStr,  "[1][2][3] rotate\n"
                    "[q][w][r] rotate\n"
                    "[a][s][d] rotate\n"
                    "[u,space] auto rotate on/off\n"
                    "[r] reset position\n"
                    "[i] wire frame on/off\n"
                    "[m] change modeling (gauroud/flat)\n"
                    "[+] zoom in\n"
                    "[-] zoom out\n"
                    "[t] texture on/off\n"
                    "[f] fog on/off\n"
                    "[p] light parallel/point\n"
                    "[o] open FUTA\n"
                    "[l] specular on/off\n"
                    "[c] multiple glDrawArrays\n"
                    "\n"
                    " Win32 Code : Min Chul , Kim (mckim@tesk-toshiba.co.kr)");
    MessageBox(0,tmpStr,"About this ::",0);
}

/********************************************************************
** Set persfective ratio on screen.
** it have been exists in GLUT32 as glPersfective(), 
** but it is not in OpenGLES. please do not use glPersfective() !!!
*********************************************************************/
void setPersfective(GLfloat fovy,GLfloat aspect,GLfloat zNear,GLfloat zFar)
{
    GLfloat xmin, xmax, ymin, ymax;
    
    ymax = zNear * (GLfloat)tan(fovy * 3.14 / 360);
    ymin = -ymax;
    xmin = ymin * aspect;
    xmax = ymax * aspect;
    
    glFrustum(xmin,xmax,ymin,ymax,zNear,zFar);
}

/********************************************************************
** Initialize 
*********************************************************************/
void InitGL(void)
{    
    int i, j;

    for (i=0; i<sizeof(cube_vtx)/sizeof(cube_vtx[0]); i++) {
	cube_vtx[i][0] = cube_vtx2[i][0];
	cube_vtx[i][1] = cube_vtx2[i][1];
	cube_vtx[i][2] = cube_vtx2[i][2];
    }

    for (i=0; i<27; i++) {
	cubepos[i] = i;
	for (j=0; j<6; j++) {
	    FaceColorIdx[i][j] = j;
	}
    }

    for (i=0; i<sizeof(cubeedge_vtx)/sizeof(cubeedge_vtx[0]); i++) {
	cubeedge_vtx[i][0] = cube_vtx[cubeedge_idx[i]][0];
	cubeedge_vtx[i][1] = cube_vtx[cubeedge_idx[i]][1];
	cubeedge_vtx[i][2] = cube_vtx[cubeedge_idx[i]][2];
	cubeedge_norm[i][0] = cube_norm[cubeedge_idx[i]][0];
	cubeedge_norm[i][1] = cube_norm[cubeedge_idx[i]][1];
	cubeedge_norm[i][2] = cube_norm[cubeedge_idx[i]][2];
    }

    for (i=0; i<sizeof(cubecnr_vtx)/sizeof(cubecnr_vtx[0]); i++) {
	cubecnr_vtx[i][0] = cube_vtx[cubecnr_idx[i]][0];
	cubecnr_vtx[i][1] = cube_vtx[cubecnr_idx[i]][1];
	cubecnr_vtx[i][2] = cube_vtx[cubecnr_idx[i]][2];
	cubecnr_norm[i][0] = cube_norm[cubecnr_idx[i]][0];
	cubecnr_norm[i][1] = cube_norm[cubecnr_idx[i]][1];
	cubecnr_norm[i][2] = cube_norm[cubecnr_idx[i]][2];
    }

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
	
	setPersfective(45.0,0.8,1,100);

	glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();

    glPixelStorei(GL_UNPACK_ALIGNMENT,1);

	glLightfv(GL_LIGHT0 , GL_POSITION , pointlightPos);
    glLightfv(GL_LIGHT0 , GL_DIFFUSE , lightCol);
    glLightfv(GL_LIGHT0,GL_AMBIENT,light0_ambient);
    glLightfv(GL_LIGHT0,GL_SPECULAR,light0_specular);
    glEnable(GL_LIGHTING);
    glEnable(GL_LIGHT0);
    glEnable(GL_NORMALIZE);
    glEnable(GL_DEPTH_TEST);

    glFogf(GL_FOG_MODE , GL_LINEAR);
    glFogf(GL_FOG_START , 3);
    glFogf(GL_FOG_END , 20);
    glFogfv(GL_FOG_COLOR, BackClearColor);

    glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, 100);
    glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE , materialCol); 
    glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR , material_specular); 

    glEnableClientState(GL_VERTEX_ARRAY);
    glEnableClientState(GL_NORMAL_ARRAY);

    shuffle();

    glClearColor(BackClearColor[0],BackClearColor[1],BackClearColor[2],BackClearColor[3]);

}

/********************************************************************
** Update current situation
*********************************************************************/
void UpdateGL(void)
{
    int i;
    static int pause_cnt;

    if (nowrot == 90) {
	if (rotidx > 8) {
	    rotcubes(rotidx-10);
	    rotcubes(rotidx-10);
	    rotcubes(rotidx-10);
	} else {
	    rotcubes(rotidx);
	}
	nowrot = 0;
	rotidx = -1;
    } else if (rotidx > -1) {
	for(i=0; i<9; i++) {
	    switch (rotidx) {
	    case 0:
	    case 1:
	    case 2:
		cube[cubepos[rottb[rotidx][0][i]]].rz-=2;
		break;
	    case 3:
	    case 4:
	    case 5:
		cube[cubepos[rottb[rotidx][0][i]]].rx-=2;
		break;
	    case 6:
	    case 7:
	    case 8:
		cube[cubepos[rottb[rotidx][0][i]]].ry+=2;
		break;
	    case 10:
	    case 11:
	    case 12:
		cube[cubepos[rottb[rotidx-10][0][i]]].rz+=2;
		break;
	    case 13:
	    case 14:
	    case 15:
		cube[cubepos[rottb[rotidx-10][0][i]]].rx+=2;
		break;
	    case 16:
	    case 17:
	    case 18:
		cube[cubepos[rottb[rotidx-10][0][i]]].ry-=2;
		break;
	    }
	}
	nowrot+=2;
    }
    
    if (autodrive) {
	rotx -= 1 % 720 / 2.;
	roty -= 2 % 720 / 2.;
	//rotz += 1 % 360;
	if (pause_cnt > 0) {
	    pause_cnt--;
	} else {
	    if (rotidx == -1) {
		rotidx = *shufflep++;
		if (*shufflep == -1) {
		    if (shufflep == &shuffle_buf[N_SHUFFLE]) {
			shufflep = shuffle_rbuf;
			pause_cnt = 300;
		    } else {
			shufflep = shuffle_buf;
		    }
		}
	    }
	}
    }

}

/********************************************************************
** Draws models .
*********************************************************************/
void DrawGL(void)
{
    int i, x, y, z, n;

    glPushMatrix();

    glTranslatef(sx, 0, sz);
    glRotatef(rotx, 1, 0, 0);
    glRotatef(roty, 0, 1, 0);

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
    for (x=0; x<3; x++) {
	for (y=0; y<3; y++) {
	    for (z=0; z<3; z++) {

		glPushMatrix();

		n = cubepos[x+y*3+z*9];

		glRotatef(cube[n].rx, 1, 0, 0);
		glRotatef(cube[n].ry, 0, 1, 0);
		glRotatef(cube[n].rz, 0, 0, 1);
		
		glTranslatef(x-1, y-1, z-1);

		glVertexPointer(3, GL_FLOAT, 0, cube_vtx);
		glNormalPointer(GL_FLOAT, 0, cube_norm);
		for (i=0; i<6; i++) {
		    glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE , FaceColor[n][FaceColorIdx[n][i]]);
		    if (wireframe)
			glDrawArrays(GL_LINE_STRIP, i*4, 4);
		    else
			glDrawArrays(GL_TRIANGLE_STRIP, i*4, 4);
		    nvtx+=4;
		}

		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE , cubeedge_color);
		glVertexPointer(3, GL_FLOAT, 0, cubeedge_vtx);
		glNormalPointer(GL_FLOAT, 0, cubeedge_norm);
		for (i=0; i<12; i++) {
		    if (wireframe)
			glDrawArrays(GL_LINE_STRIP, i*4, 4);
		    else
			glDrawArrays(GL_TRIANGLE_STRIP, i*4, 4);
		    nvtx+=4;
		}

		glVertexPointer(3, GL_FLOAT, 0, cubecnr_vtx);
		glNormalPointer(GL_FLOAT, 0, cubecnr_norm);
		if (!wireframe)
		    glDrawArrays(GL_TRIANGLES, 0, 3*8);
		nvtx+=3*8;
		
		glPopMatrix();
	    }
	}
    }

    glPopMatrix();

}

void KeyControl(int key)
{
    if (rotidx == -1) {
    	switch (key) {
        	case KEY_1:
        	    rotidx = 0;
        	    break;
        	case KEY_2:
        	    rotidx = 1;
        	    break;
        	case KEY_3:
        	    rotidx = 2;
        	    break;
        	case KEY_4:
        	    rotidx = 3;
        	    break;
        	case KEY_5:
        	    rotidx = 4;
        	    break;
        	case KEY_6:
        	    rotidx = 5;
        	    break;
        	case KEY_A:
        	    rotidx = 6;
        	    break;
        	case KEY_S:
        	    rotidx = 7;
        	    break;
        	case KEY_D:
        	    rotidx = 8;
        	    break;
    	}
    }
    switch (key) {
        case VK_F1:
            showHelp();
            break;
        case KEY_Z:
    	sz+=0.1;
    	break;
        case KEY_X:
    	sz-=0.1;
    	break;
        case KEY_LEFT:
    	roty-=5;
    	break;
        case KEY_RIGHT:
    	roty+=5;
    	break;
        case KEY_UP:
    	rotx-=5;
    	break;
        case KEY_DOWN:
    	rotx+=5;
    	break;
        case KEY_R:	// reset position
    	sz = -7;
    	sx = 0;
    	rotx = 0;
    	roty = 0;
    	rotz = 0;
    	break;
        case KEY_T:	// enable/disable texture
    	texture = !texture;
    	if (texture) {
    	    glEnable(GL_TEXTURE_2D);
    	} else {
    	    glDisable(GL_TEXTURE_2D);
    	}
    	break;
        case KEY_F:	// enable/disable fog
    	fog = !fog;
    	if (fog) {
    	    glEnable(GL_FOG);
        	    printf("\nfog enabled\n");
    	} else {
    	    glDisable(GL_FOG);
        	    printf("\nfog disabled\n");
    	}
    	break;
    	case KEY_SPACE:
        case KEY_U:	// auto	drive
    	autodrive = !autodrive;
    	break;
        case KEY_P:
    	pointlight = !pointlight;
    	glPushMatrix();
    	if (pointlight) {
    	    glLightfv(GL_LIGHT0 , GL_POSITION , pointlightPos);
        	    printf("\nlight=point\n");
    	} else {
    	    glLightfv(GL_LIGHT0 , GL_POSITION , lightPos);
        	    printf("\nlight=parallel\n");
    	}
    	glPopMatrix();
    	break;
        case KEY_I:
    	wireframe = !wireframe;
    	break;
        case KEY_M:
    	flatshade = !flatshade;
    	if (flatshade)
    	    glShadeModel(GL_FLAT);
    	else 
    	    glShadeModel(GL_SMOOTH); 
    	break;
        case KEY_L:
    	supecular = !supecular;
    	if (supecular) {
    	    glLightfv(GL_LIGHT0, GL_SPECULAR, light0_specular);
    	    glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, material_specular);
    	} else {
    	    glLightfv(GL_LIGHT0, GL_SPECULAR, lightNone);
    	    glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, lightNone);
    	}
    	break;
    	case KEY_PLUS:
            sz++;
            break;
        case KEY_MINUS:
            sz--;
            break;
    }

}

/********************************************************************
** It be called when states going out.
*********************************************************************/
void CloseGL(void)
{
    
}

